> This page is for Developers.

> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://zuora.ferndocs.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://zuora.ferndocs.com/_mcp/server.

# Configure cascading payment methods for an account

PUT https://rest.test.zuora.com/v1/accounts/{account-key}/payment-methods/cascading
Content-Type: application/json

Zuora provides the Cascading Payment Method feature to dynamically retry the failed payment with alternative payment methods according to a predefined priority list. Use this API operation to configure the cascading consent for a specified account and set up the priority list of payment methods to be used in Cascading Payment Method.

Before you use this API operation, ensure that the Cascading Payment Method feature is enabled. For more information about the Cascading Payment Method feature, see Cascade payment methods.

Reference: https://zuora.ferndocs.com/developers/api-reference/zuora-api/customer-accounts/accounts/put-account-payment-method-cascading

## Authentication

- `Authorization` header (bearer token, required) — Use `Bearer {{token}}` in the `Authorization` header for authentication.

## Servers

- `https://rest.test.zuora.com` (US Developer & Central Sandbox (incl. Test Drive), default)
- `https://rest.sandbox.na.zuora.com` (US API Sandbox Cloud 1)
- `https://rest.apisandbox.zuora.com` (US API Sandbox Cloud 2)
- `https://rest.na.zuora.com` (US Production Cloud 1)
- `https://rest.zuora.com` (US Production Cloud 2)
- `https://rest.test.eu.zuora.com` (EU Developer & Central Sandbox)
- `https://rest.sandbox.eu.zuora.com` (EU API Sandbox)
- `https://rest.eu.zuora.com` (EU Production)
- `https://rest.test.ap.zuora.com` (APAC Developer & Central Sandbox)
- `https://rest.ap.zuora.com` (APAC Production)

## Request

### Path parameters

- `account-key` (string, required) — Account ID.

### Headers

- `Accept-Encoding` (string, optional) — Include the `Accept-Encoding: gzip` header to compress responses as a gzipped file. It can significantly reduce the bandwidth required for a response. If specified, Zuora automatically compresses responses that contain over 1000 bytes of data, and the response contains a `Content-Encoding` header with the compression algorithm so that your client can decompress it.
- `Content-Encoding` (string, optional) — Include the `Content-Encoding: gzip` header to compress a request. With this header specified, you should upload a gzipped file for the request payload instead of sending the JSON payload.
- `Zuora-Track-Id` (string, optional) — A custom identifier for tracing the API call. If you set a value for this header, Zuora returns the same value in the response headers. This header enables you to associate your system process identifiers with Zuora API calls, to assist with troubleshooting in the event of an issue. The value of this field must use the US-ASCII character set and must not include any of the following characters: colon (`:`), semicolon (`;`), double quote (`"`), and quote (`'`).
- `Zuora-Entity-Ids` (string, optional) — An entity ID. If you have [Zuora Multi-entity](https://knowledgecenter.zuora.com/BB_Introducing_Z_Business/Multi-entity) enabled and the OAuth token is valid for more than one entity, you must use this header to specify which entity to perform the operation in. If the OAuth token is only valid for a single entity, or you do not have Zuora Multi-entity enabled, you should not set this header.
- `Zuora-Org-Ids` (string, optional) — Comma separated IDs. If you have Zuora Multi-Org enabled, you can use this header to specify which orgs to perform the operation in. If you do not have Zuora Multi-Org enabled, you should not set this header. The IDs must be a sub-set of the user's accessible orgs. If you specify an org that the user does not have access to, the operation fails. This header is important in Multi-Org (MO) setups because it defines the organization context under which the API should operate—mainly used for read access or data visibility filtering. If the header is not set, the operation is performed in scope of the user's accessible orgs.
- `Zuora-Version` (string, optional) — The minor API version. For a list of available minor versions, see [API upgrades](https://developer.zuora.com/v1-api-reference/api-upgrades/).

### Body (application/json)

This endpoint expects a PutCascadingPaymentMethodsConfigurationRequest.

- `consent` (boolean, optional) — `true` indicates that you have collected consent from your customer to use the Cascading Payment Method feature. `false` indicates the consent was not collected and the Cascading Payment Method feature is not enabled. The `priorities` field can be specified only if `consent` is `true`.
- `priorities` (list of PutCascadingPaymentMethodsConfigurationRequestPrioritiesItems, optional) — Container for the priority configuration of payment methods. You can add up to three payment methods to this container. For more information, see Cascade payment methods. `priorities` is required if `consent` is `true`.

## Response

### 200

OK

- `processId` (string, optional) — The ID of the process that handles the operation.
- `reasons` (list of CommonResponseReasonsItems, optional) — The container of the error code and message. This field is available only if the `success` field is `false`.
- `requestId` (string, optional) — Unique identifier of the request.
- `success` (boolean, optional) — Indicates whether the call succeeded.

## Errors

### 500 Internal Server Error

Internal Server Error

- `reasons` (list of ErrorResponseReasonsItems, optional)

### 400 Client Request Error

Request Errors

- `processId` (string, optional) — The ID of the process that handles the operation.
- `reasons` (list of CommonResponseReasonsItems, optional) — The container of the error code and message. This field is available only if the `success` field is `false`.
- `requestId` (string, optional) — Unique identifier of the request.
- `success` (boolean, optional) — Indicates whether the call succeeded.

## Types

### PutCascadingPaymentMethodsConfigurationRequestPrioritiesItems

- `paymentMethodId` (string, required) — The ID of a payment method.
- `order` (integer, required) — The order of the payment method in the priority list. For example, `1` indicates the payment method is the first one in the priority list, and `2` indicates it is the second. The first payment method in the priority list will be the default payment method of the customer account.

### CommonResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

### ErrorResponseReasonsItems

- `code` (string, optional) — The error code of response.
- `message` (string, optional) — The detail information of the error response

## Examples

**Request**

```json
{
  "consent": true,
  "priorities": [
    {
      "paymentMethodId": "2c92c0f95be68649015bf14e001f2760",
      "order": 1
    },
    {
      "paymentMethodId": "2c92c0f95be68649015bf14e001f2761",
      "order": 2
    },
    {
      "paymentMethodId": "2c92c0f95be68649015bf14e001f2762",
      "order": 3
    }
  ]
}
```

**Response**

```json
{
  "success": true
}
```

**SDK Code**

```python response
import requests

url = "https://rest.test.zuora.com/v1/accounts/account-key/payment-methods/cascading"

payload = {
    "consent": True,
    "priorities": [
        {
            "paymentMethodId": "2c92c0f95be68649015bf14e001f2760",
            "order": 1
        },
        {
            "paymentMethodId": "2c92c0f95be68649015bf14e001f2761",
            "order": 2
        },
        {
            "paymentMethodId": "2c92c0f95be68649015bf14e001f2762",
            "order": 3
        }
    ]
}
headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.put(url, json=payload, headers=headers)

print(response.json())
```

```javascript response
const url = 'https://rest.test.zuora.com/v1/accounts/account-key/payment-methods/cascading';
const options = {
  method: 'PUT',
  headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
  body: '{"consent":true,"priorities":[{"paymentMethodId":"2c92c0f95be68649015bf14e001f2760","order":1},{"paymentMethodId":"2c92c0f95be68649015bf14e001f2761","order":2},{"paymentMethodId":"2c92c0f95be68649015bf14e001f2762","order":3}]}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go response
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://rest.test.zuora.com/v1/accounts/account-key/payment-methods/cascading"

	payload := strings.NewReader("{\n  \"consent\": true,\n  \"priorities\": [\n    {\n      \"paymentMethodId\": \"2c92c0f95be68649015bf14e001f2760\",\n      \"order\": 1\n    },\n    {\n      \"paymentMethodId\": \"2c92c0f95be68649015bf14e001f2761\",\n      \"order\": 2\n    },\n    {\n      \"paymentMethodId\": \"2c92c0f95be68649015bf14e001f2762\",\n      \"order\": 3\n    }\n  ]\n}")

	req, _ := http.NewRequest("PUT", url, payload)

	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby response
require 'uri'
require 'net/http'

url = URI("https://rest.test.zuora.com/v1/accounts/account-key/payment-methods/cascading")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Put.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"consent\": true,\n  \"priorities\": [\n    {\n      \"paymentMethodId\": \"2c92c0f95be68649015bf14e001f2760\",\n      \"order\": 1\n    },\n    {\n      \"paymentMethodId\": \"2c92c0f95be68649015bf14e001f2761\",\n      \"order\": 2\n    },\n    {\n      \"paymentMethodId\": \"2c92c0f95be68649015bf14e001f2762\",\n      \"order\": 3\n    }\n  ]\n}"

response = http.request(request)
puts response.read_body
```

```java response
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.put("https://rest.test.zuora.com/v1/accounts/account-key/payment-methods/cascading")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"consent\": true,\n  \"priorities\": [\n    {\n      \"paymentMethodId\": \"2c92c0f95be68649015bf14e001f2760\",\n      \"order\": 1\n    },\n    {\n      \"paymentMethodId\": \"2c92c0f95be68649015bf14e001f2761\",\n      \"order\": 2\n    },\n    {\n      \"paymentMethodId\": \"2c92c0f95be68649015bf14e001f2762\",\n      \"order\": 3\n    }\n  ]\n}")
  .asString();
```

```php response
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('PUT', 'https://rest.test.zuora.com/v1/accounts/account-key/payment-methods/cascading', [
  'body' => '{
  "consent": true,
  "priorities": [
    {
      "paymentMethodId": "2c92c0f95be68649015bf14e001f2760",
      "order": 1
    },
    {
      "paymentMethodId": "2c92c0f95be68649015bf14e001f2761",
      "order": 2
    },
    {
      "paymentMethodId": "2c92c0f95be68649015bf14e001f2762",
      "order": 3
    }
  ]
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp response
using RestSharp;

var client = new RestClient("https://rest.test.zuora.com/v1/accounts/account-key/payment-methods/cascading");
var request = new RestRequest(Method.PUT);
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"consent\": true,\n  \"priorities\": [\n    {\n      \"paymentMethodId\": \"2c92c0f95be68649015bf14e001f2760\",\n      \"order\": 1\n    },\n    {\n      \"paymentMethodId\": \"2c92c0f95be68649015bf14e001f2761\",\n      \"order\": 2\n    },\n    {\n      \"paymentMethodId\": \"2c92c0f95be68649015bf14e001f2762\",\n      \"order\": 3\n    }\n  ]\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift response
import Foundation

let headers = [
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "consent": true,
  "priorities": [
    [
      "paymentMethodId": "2c92c0f95be68649015bf14e001f2760",
      "order": 1
    ],
    [
      "paymentMethodId": "2c92c0f95be68649015bf14e001f2761",
      "order": 2
    ],
    [
      "paymentMethodId": "2c92c0f95be68649015bf14e001f2762",
      "order": 3
    ]
  ]
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://rest.test.zuora.com/v1/accounts/account-key/payment-methods/cascading")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "PUT"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```